

# variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable statsBlocks [list 0 1 2 3 4]
    variable statsBlock [first $statsBlocks]
    variable allblocks 0
    variable SelectedItem 1
    variable AutoUpdate 0

    variable JS ""

    variable NUM 64
    for {set i 0} {$i <= $NUM} {incr i} {
      if {![info exists ITEM($i)]} {set ITEM($i) ""}
    }


     variable Stats
     variable Rates

   proc  show_variables {} {
       variable allblocks
       variable AutoUpdate
       variable SelectedItem
       variable statsBlock

       InsertLog "allblocks=$allblocks; autoupdate=$AutoUpdate; stats block=$statsBlock; selecteditem=$SelectedItem"
   }

    proc do_update {Block} {
        variable NUM
        variable Stats
        variable Rates

       set data [ReadNetVar NetVar.MRGE.Stats$Block]

       for {set i 0} {$i < $NUM} {incr i} {
          set Stats($i) [expr [lindex $data [expr $i*2]]]
       }

       set data [ReadNetVar NetVar.MRGE.Rates$Block]

       for {set i 0} {$i < $NUM} {incr i} {
           set Rates($i) [expr [lindex $data [expr $i*2]]]
       }

   }   

    proc do_GetCounters {{block 0}} {
       variable NUM
       variable Stats

#   puts "do_GetCounters:"

       do_update $block

       set rc ""
       for {set i 0} {$i < $NUM} {incr i} {append rc "[set Stats($i)] "}

       return $rc
    }

    proc do_GetRates {{block 0}} {
       variable NUM
       variable Rates

#   puts "do_GetRates:"

       do_update $block

       set rc ""
       for {set i 0} {$i < $NUM} {incr i} {append rc "[set Rates($i)] "}

       return $rc
    }

    proc do_zero {} {

       WriteNetVar NetVar.MRGE.ZeroStats 1
       InsertLog "Statistics Zeroed"
    }

  proc PageNotes {} {InsertLog "Notes in preparation"}

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   NOTES    {PageNotes}

                   UPDATESTATS -
                   UPDATE    {}

                   AUTOUPDATE  {variable AutoUpdate; set AutoUpdate [expr ($AutoUpdate + 1) & 1]}

                   DOZERO    {do_zero}

                   COUNTER   {variable SelectedItem; set SelectedItem $vl}
                   BLOCK      {variable statsBlock; set statsBlock $vl}
                   ALLBLOCKS  {variable allblocks; set allblocks [expr ($allblocks + 1) & 1]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

    }  ;#  end of do_click

}   ;# end of if {$started == 0}




